import Taro, { Component } from '@tarojs/taro';
import './index.scss'
import { AtDivider, AtList, AtListItem, AtGrid, AtButton } from 'taro-ui'

import achievePhone from '@components/achievePhone'
import { checkinDetails, checkinActive } from '@services/checkin'

// import { checkinActive } from '@services/checkin'

export default class checkin extends Component {

  state = {
    id:'',
    // ischeck:''
    // isLogin: false,
    // user: {},
    // isAgent: false,//经纪人
    // consultant: false,//置业顾问
    // tourist: false,//普通用户
    data: {},
  }

  componentWillMount () {
    console.log(this.$router.params,'22222')

    const { id, type } = this.$router.params

    console.log(id, type)
    this.getcheckinDetails(id, type)
    // this.getcheckinDetails()

  }
  // dynamicId
  getcheckinDetails (id, type) {
    console.log('1111')
    // const id = '39a0e51e6fea9cb758abed08dd7fb16b'
    Taro.showLoading()
    checkinDetails(id, type).then(res => {
      Taro.hideLoading()
      this.setState({
        data: res
      })
      console.log('1111', res)
    })
  }

  checkinActive () {

    //  alert('签到成功')
    const enlistId = this.state.data.enlist.enlistId
    Taro.showLoading()
    checkinActive(enlistId).then(res => {
      Taro.hideLoading()
      Taro.navigateTo({
        url: '/pages/checkin/checkinsuccess/index'
      })
    }).catch((err) => {
      console.log('签到失败')
      // Taro.navigateTo({
      //   url: '/pages/checkin/checkinsuccess/index'
      // })
    })


  }

  toactivity () {
    Taro.navigateTo({
      // url: '/pages/checkin/checkinsuccess/index'
    })
  }

  render () {
    const { data, style } = this.props



    return (
      <View className="checkin" style="width:100vw;height:100vh;" >

        {/* <checkinsuccess></checkinsuccess> */}
        {/* <achievePhone></achievePhone> */}
        <View>
          <Image className="img" src={this.state.data.dynamic.imgUrl}  ></Image>
        </View>
        <View style="margin-bottom:20px"  >
          <View className="text1"> <Text>{this.state.data.dynamic.title}</Text></View>
        </View >

        {this.state.data.enlist != null && <View>
          <View style="text-align: center;">
            <Text className="line">- - - - - - - - - </Text>
            <Text className="text2">活动报名信息</Text>
            <Text className="line">- - - - - - - - - </Text>
          </View>

          <View className="text3">
            <View className='at-row'>
              <View className='at-col at-col-3'>用户名：</View>
              <View className='at-col at-col-9'>{this.state.data.person.name || this.state.data.person.nickname}</View>
            </View>
            <View className='at-row'>
              <View className='at-col at-col-3'>手机号：</View>
              <View className='at-col at-col-9'>{this.state.data.person.tel || this.state.data.person.phone}</View>
            </View>
            <View className='at-row'>
              <View className='at-col at-col-3'>参与人数：</View>
              <View className='at-col at-col-9'>{this.state.data.enlist.attendNum}</View>
            </View>
          </View>



          {!this.state.data.person.status && <Image className="checkinImg" src={require('@assets/checkin/checkin.png')} onClick={this.checkinActive}   ></Image>}
          {this.state.data.person.status && <Image className="checkinImg" src={require('@assets/checkin/checkined.png')}></Image>}
        </View>}
        {this.state.data.enlist == null && <View className="unregistered">
          <View>
            <Image className="img1" src={require('@assets/checkin/noentry.png')} ></Image>
          </View>
          <View className="message">
            <Text className="messageText" >您还未报名当前活动,请先前往活动报名页报名成功后再进行扫码签到~ </Text>

          </View>

          <AtButton type='primary' className="toactivebutton">立即前往</AtButton>
          {/* <Image src={require('@assets/checkin/checkin.png')}  style="position: absolute; width:110px;height:110px ;bottom:12vh;left:132.5px"  ></Image> */}
        </View>}
      </View>

    );
  }
}