import Taro, { Component } from '@tarojs/taro';
import './index.scss'

export default class ReportItem extends Component {
  static defaultProps = {
    data: []
  }
  handleClick() {
    this.props.onClick(this.props.data)
  }
  render() {
    const { data } = this.props
    return (
      <View className="item">
        <Image className="item-img" mode="aspectFill" src={data.reportImg}></Image>
        <View className="item-con">
          <View className="item-con__title">报备客户</View>
          <View className="item-con__name">{data.name}</View>
          <View className="item-con__tel">{data.phone}<Icon className='iconfont icon-dianhua1'></Icon></View>
          <View className="item-con__date">{data.creatDate}<Text className='add-btn'>维护信息</Text></View>
        </View>
      </View>
    );
  }
}