import Taro, { Component } from '@tarojs/taro'
import './index.scss'
import emptyImg  from '@assets/empty.png'
export default class EmptyPage extends Component {
  static defaultProps = {
    text: '暂无数据~'
  }
  render() {
    
    const {text} = this.props
    return (
      <View className="empty">
        <Image className="empty__img" mode="widthFix" src={emptyImg}></Image>
        <View className="empty__text">{text}</View>
      </View>
    )
  }
}
