import Taro, { Component } from '@tarojs/taro'
import './index.scss'

export default class Loadmore extends Component {
  static defaultProps = {
    loading: true,
    loadend: false,
    nodata: false
  }
  render() {
    const { loading, loadend, nodata } = this.props
    return (
      <View className="load">
        {loading && <View className="row load-more">正在加载…</View>}
        {loadend && <View className="row load-end">没有更多数据了…</View>}
        {nodata && <View className="row load-empty">暂无数据~</View>}
      </View>
    )
  }
}
