import Taro, { Component } from '@tarojs/taro';
import './index.scss'
// import "@styles/icon.scss";
export default class Index extends Component {
  static defaultProps = {
    num: 0,
    avatar: require('@assets/default-avatar.png')
  }
  static options = {
    addGlobalClass: true
  }
  render() {
    const { avatar, num, onClick } = this.props

    return (
      <View className="notice" onClick={onClick}>
        <View>
          <Image className='notice__img' src={avatar} mode="aspectFill"></Image>
          <Text className="notice__text">您有<Text className="num">{num}</Text>条未读消息哦~</Text>
        </View>
        <Text className="iconfont icon-jiantou-copy"></Text>
      </View>
    );
  }
}